# Compile time configuration:

SET(ENABLE_APPLICABILITY_FILTERING OFF)
SET(ENABLE_APPLICABILITY_CACHE OFF) # Optimization when using applicability filtering.
SET(ENABLE_TERMINAL_STATE_SUPPORT OFF)
SET(REACH_MAY_BE_TERMINAL ON) # Reach states may be terminal -- disable to encode reach-avoid.

# PA:

set(LAZY_PA OFF)
set(QUERY_PER_BRANCH_INIT ON) # Query satisfiability for each predicate set during initial state enumeration.
set(QUERY_PER_BRANCH_EXPANSION OFF) # Query satisfiability for each predicate set during the predicate state enumeration of expansion.
set(ENABLE_HEURISTIC_SEARCH_PA ON) # Enable heuristic search options for predicate abstraction.
set(CACHE_WITNESSES ON) # Enable support for concrete witness state caching.

set(PA_ONLY_REACHABILITY OFF) # Only check for reachability, skipping redundant transition tests.
set(PA_ONLY_STEP_REACHABILITY ON) # Only check for step-reachability, skipping redundant transition tests.
set(PA_ONLY_STEP_REACHABILITY_PER_LABEL OFF) # Only check for step-reachability per action label, skipping redundant transition tests.
set(PA_ONLY_STEP_REACHABILITY_PER_OPERATOR OFF) # Only check for step-reachability per action operator, skipping redundant transition tests.

# Transition tests
set(REUSE_SOLUTIONS ON) # Try to reuse solutions of previous queries.
set(ROUND_RELAXED_SOLUTIONS ON) # Round relaxed solutions to check for integer solution; by default if reusing solutions
set(DO_SELECTION_TEST OFF) # Enable action selection tests.
set(DO_NN_APPLICABILITY_TEST OFF) # Enable (NN-SAT) applicability tests.
set(DO_RELAXED_SELECTION_TEST_ONLY OFF) # Only support relaxed action selection tests.
set(DO_RELAXED_NN_APPLICABILITY_TEST_ONLY OFF) # Only support relaxed (NN-SAT) applicability tests.
# Reusing solutions:
# Applicability test are redundant on e.g. deterministic npuzzle (under entailment optimizations and given box constraint predicates).
# Here reusing solutions will help, alternatively one might disable either applicability or transition tests (in the former case however effectively disabling step-reachability caching).

# Technical (enabled as runtime option)
SET(ENABLE_STALLING_DETECTION OFF) # CURRENTLY NOT MAINTAINED/SUPPORTED
SET(ENABLE_QUERY_CACHING OFF) # CURRENTLY NOT MAINTAINED/SUPPORTED

# Marabou

SET(MARABOU_DNC_SUPPORT OFF) # CURRENTLY NOT MAINTAINED/SUPPORTED
SET(MARABOU_DIS_BASELINE_SUPPORT OFF) # If disabled all disjunctions optimizations are used.
