//
// This file is part of the Marabou extension for PlaJA (2019 - 2024).
//

#ifndef PLAJA_ENUM_OPTION_VALUES_H
#define PLAJA_ENUM_OPTION_VALUES_H

#include <memory>
#include <string>
#include "../include/factory_config_const.h"

namespace PLAJA_OPTION {

    /**
     * Global enum for special option values.
     */
    enum class EnumOptionValue { // NOLINT(*-enum-size)

        None,

#ifdef BUILD_TO_NUXMV
        /* NuXmv default configs. */
        Bmc,
        SBmc,
        Coi,
        IpaBmc,
        IpaCegar,
        Cegar,
        Ic3,
#endif

    };

    extern std::unique_ptr<EnumOptionValue> str_to_enum_option_value(const std::string& str);

    extern std::string enum_option_value_to_str(EnumOptionValue value);

    class EnumOptionValuesSet;

}

#endif //PLAJA_ENUM_OPTION_VALUES_H
