//
// This file is part of the PlaJA code base (2019 - 2020).
//

#ifndef PLAJA_PLAJA_OPTIONS_H
#define PLAJA_PLAJA_OPTIONS_H

#include <string>

namespace PLAJA_OPTION {

    extern const std::string help;

    // Engines
    extern const std::string engine;
    extern const std::string max_time;
    extern const std::string print_time;

    // Model & Properties
    extern const std::string model_file;
    extern const std::string prop;
    extern const std::string additional_properties;
    extern const std::string allow_locals;
    extern const std::string nn_interface;
    extern const std::string nn_for_racetrack;
    extern const std::string nn;
    extern const std::string torch_model;
    extern const std::string applicability_filtering;
    extern const std::string ignore_nn;

    // Constants
    extern const std::string consts;

    // Statistics
    extern const std::string print_stats;
    extern const std::string stats_file;
    extern const std::string save_intermediate_stats;
    extern const std::string savePath;
    extern const std::string saveStateSpace;

    // Parsing
    extern const std::string ignore_unexpected_json;
    extern const std::string pa_objective;
    extern const std::string set_pa_goal_objective_terminal;

    // Misc
    extern const std::string seed;
    extern const std::string local_backup;
    extern const std::string additional_initial_states;
    extern const std::string naive_initial_state_enum;

}

namespace PLAJA_OPTION_DEFAULT {

    constexpr unsigned int max_time = 1800;

    constexpr int applicability_filtering = 0;

    constexpr bool set_pa_goal_objective_terminal(false);

}

#endif //PLAJA_PLAJA_OPTIONS_H
