//
// This file is part of the PlaJA code base (2019 - 2019).
//

#include "constant_declaration.h"
#include "../visitor/ast_visitor.h"
#include "../visitor/ast_visitor_const.h"
#include "type/declaration_type.h"
#include "expression/expression.h"

ConstantDeclaration::ConstantDeclaration():
    name(PLAJA_UTILS::emptyString)
    , /*id(-1),*/
    declarationType()
    , value() {
}

ConstantDeclaration::~ConstantDeclaration() = default;

// setter:

void ConstantDeclaration::set_declarationType(std::unique_ptr<DeclarationType>&& decl_type) { declarationType = std::move(decl_type); }

void ConstantDeclaration::set_value(std::unique_ptr<Expression>&& val) { value = std::move(val); }

//

std::unique_ptr<ConstantDeclaration> ConstantDeclaration::deepCopy() const {
    std::unique_ptr<ConstantDeclaration> copy(new ConstantDeclaration());
    copy->copy_comment(*this);
    copy->set_name(name);
    // copy->id = id;
    if (declarationType) { copy->set_declarationType(declarationType->deep_copy_decl_type()); }
    if (value) { copy->set_value(value->deepCopy_Exp()); }
    return copy;
}

// override:

void ConstantDeclaration::accept(AstVisitor* ast_visitor) { ast_visitor->visit(this); }

void ConstantDeclaration::accept(AstVisitorConst* ast_visitor) const { ast_visitor->visit(this); }





