//
// This file is part of the PlaJA code base (2019 - 2023).
//

#ifndef PLAJA_EXPRESSION_UTILS_H
#define PLAJA_EXPRESSION_UTILS_H

#include <memory>
#include "../../ast_forward_declarations.h"
#include "../../using_parser.h"

namespace PLAJA_EXPRESSION {
    [[nodiscard]] extern std::unique_ptr<ConstantValueExpression> make_bool(bool value);
    [[nodiscard]] extern std::unique_ptr<ConstantValueExpression> make_int(PLAJA::integer value);
    [[nodiscard]] extern std::unique_ptr<ConstantValueExpression> make_real(PLAJA::floating value);
}

#endif //PLAJA_EXPRESSION_UTILS_H
