//
// This file is part of the PlaJA code base (2019 - 2020).
//

#include "is_constant.h"
#include "../ast/expression/lvalue_expression.h"
#include "../ast/assignment.h"
#include "../ast/model.h"

IsConstant::IsConstant(const Model& model){
    model.accept(this);
}

IsConstant::~IsConstant() = default;

bool IsConstant::is_constant(VariableID_type var_id) {
    return !nonConstantVars.count(var_id);
}

bool IsConstant::is_constant(VariableID_type var_id, const Model& model) {
    return IsConstant(model).is_constant(var_id);
}

// visits:

void IsConstant::visit(const Assignment* assignment) {
    nonConstantVars.insert(assignment->get_ref()->get_variable_id());
}