//
// This file is part of the PlaJA code base (2019 - 2020).
//

#ifndef PLAJA_IS_CONSTANT_H
#define PLAJA_IS_CONSTANT_H

#include <unordered_set>
#include "ast_visitor_const.h"
#include "../using_parser.h"

class IsConstant: public AstVisitorConst {
private:
    std::unordered_set<VariableID_type> nonConstantVars;
public:
    explicit IsConstant(const Model& model);
    ~IsConstant() override;

    bool is_constant(VariableID_type var_id);
    static bool is_constant(VariableID_type var_id, const Model& model);

    // visits:
    void visit(const Assignment* assignment) override;
};


#endif //PLAJA_IS_CONSTANT_H
