//
// This file is part of the Marabou extension for PlaJA (2019 - 2023).
//

#ifndef PLAJA_SPLIT_ON_LOCS_H
#define PLAJA_SPLIT_ON_LOCS_H

#include <list>
#include <memory>
#include "../ast_visitor.h"

class ExtractStateCondition final: private AstVisitor {

private:
    std::unique_ptr<StateConditionExpression> stateCondition;
    bool moved; // NOLINT(*-use-default-member-init)

    void visit(StateConditionExpression* exp) override;

    ExtractStateCondition();
public:
    ~ExtractStateCondition() override;
    DELETE_CONSTRUCTOR(ExtractStateCondition)

    [[nodiscard]] static std::unique_ptr<StateConditionExpression> extract(std::list<std::unique_ptr<Expression>>& conjuncts);

};

/**********************************************************************************************************************/

class SplitOnLocs final/*: private AstVisitor*/ {

    SplitOnLocs();
public:
    ~SplitOnLocs() /*override*/;
    DELETE_CONSTRUCTOR(SplitOnLocs)

    /** Split top-conjunction into StateConditionExpression -- locations constraints and state variable constraints separated. */
    [[nodiscard]] static std::unique_ptr<StateConditionExpression> split(std::unique_ptr<Expression>&& expr);

};

#endif //PLAJA_SPLIT_ON_LOCS_H
