//
// This file is part of the PlaJA code base (2019 - 2019).
//

#include "set_constants.h"
#include "../../exception/semantics_exception.h"
#include "../ast/expression/constant_expression.h"
#include "../ast/expression/constant_value_expression.h"

SetConstants::SetConstants(const std::unordered_map<std::string, const ConstantValueExpression*>& name_to_value): name_to_value(name_to_value) {}

SetConstants::~SetConstants() = default;

void SetConstants::visit(ConstantExpression* exp) { exp->set_value(name_to_value.at(exp->get_name())->deepCopy_ConstantValueExp()); }

void SetConstants::set_constants(const std::unordered_map<std::string, const ConstantValueExpression*>& name_to_value, AstElement& astEl) {
    SetConstants setConstants(name_to_value);
    astEl.accept(&setConstants);
}
