//
// This file is part of the PlaJA code base (2019 - 2019).
//

#ifndef PLAJA_SET_CONSTANTS_H
#define PLAJA_SET_CONSTANTS_H


#include <unordered_map>
#include <string>
#include "ast_visitor.h"

// forward declaration
class AstElement;
class ConstantValueExpression;

class SetConstants: public AstVisitor {
private:
    const std::unordered_map<std::string, const ConstantValueExpression*>& name_to_value;
    explicit SetConstants(const std::unordered_map<std::string, const ConstantValueExpression*>& name_to_value);
public:
    ~SetConstants() override;
    void visit(ConstantExpression* exp) override;
    static void set_constants(const std::unordered_map<std::string, const ConstantValueExpression*>& name_to_value, AstElement& astEl);

};


#endif //PLAJA_SET_CONSTANTS_H
