//
// This file is part of the Marabou extension for PlaJA (2019 - 2023).
//

#ifndef PLAJA_EXPLORER_TEACHER_H
#define PLAJA_EXPLORER_TEACHER_H

#include <memory>
#include "policy_teacher.h"

class SpaceExplorer;

class ExplorerTeacher final: public PolicyTeacher {

private:
    std::unique_ptr<PropertyInformation> propInfo;
    std::unique_ptr<PLAJA::Configuration> configExplorer;
    std::unique_ptr<SpaceExplorer> explorer;

public:
    explicit ExplorerTeacher(const PLAJA::Configuration& config);
    ~ExplorerTeacher() override;
    DELETE_CONSTRUCTOR(ExplorerTeacher)

    [[nodiscard]] ActionLabel_type get_action(const StateBase& state) const override;

};

#endif //PLAJA_EXPLORER_TEACHER_H
