//
// This file is part of the PlaJA code base (2019 - 2019).
//

#ifndef PLAJA_BREADTH_FIRST_SEARCH_H
#define PLAJA_BREADTH_FIRST_SEARCH_H

#include "base/search_engine_base.h"

class SearchSpaceBFS;

class BFSearch final: public SearchEngineNonProbBase {
    friend struct InitializeBase;
    friend struct StepBase;

private:
    std::unique_ptr<SearchSpaceBFS> searchSpace;

    [[nodiscard]] SearchStatus initialize(StateID_type initial_id) override;
    SearchStatus step() override;

public:
    explicit BFSearch(const PLAJA::Configuration& config);
    ~BFSearch() override;
    DELETE_CONSTRUCTOR(BFSearch)

    SearchStatus finalize() override;

};

#endif //PLAJA_BREADTH_FIRST_SEARCH_H
