//
// This file is part of the PlaJA code base (2019 - 2021).
//

#ifndef PLAJA_INITIAL_STATES_ENUMERATOR_H
#define PLAJA_INITIAL_STATES_ENUMERATOR_H

#include <list>

// forward declaration:
class Expression;
class Model;
class StateConditionExpression;
class StateValues;
class StatesValuesExpression;

class InitialStatesEnumerator {

private:

    static std::list<StateValues> compute_initial_states(const Model& model, const StatesValuesExpression& initial_states_values);
    static std::list<StateValues> compute_initial_states(const Model& model, const StateConditionExpression& initial_state_condition);

public:
    static std::list<StateValues> compute_initial_states(const Model& model, const Expression& condition);
};

#endif //PLAJA_INITIAL_STATES_ENUMERATOR_H
