//
// This file is part of the PlaJA code base (2019 - 2021).
//

#ifndef PLAJA_NN_EXPLORER_H
#define PLAJA_NN_EXPLORER_H

#include "base/search_engine_base.h"

class PolicyRestriction;

namespace NN_EXPLORER { class SearchSpace; }

class NN_Explorer final: public SearchEngineExplorerBase {
    friend struct InitializeBase;
    friend struct StepBase;

private:
    std::unique_ptr<NN_EXPLORER::SearchSpace> searchSpace;

    [[nodiscard]] SearchStatus initialize(StateID_type initial_id) override;
    SearchStatus step() override;
    SearchStatus finalize() override;
    void compute_inevitable_goal_path_states();
    void compute_policy_goal_path_states();

public:
    explicit NN_Explorer(const PLAJA::Configuration& config);
    ~NN_Explorer() override;
    DELETE_CONSTRUCTOR(NN_Explorer)

};

#endif //PLAJA_NN_EXPLORER_H
