//
// This file is part of the PlaJA code base (2019 - 2020).
//

#ifndef PLAJA_SPACE_EXPLORER_H
#define PLAJA_SPACE_EXPLORER_H

#include <list>
#include <memory>
#include "base/search_engine_base.h"

namespace SPACE_EXPLORER { class SearchSpace; }

/** Implementation to construct the state space. */
class SpaceExplorer final: public SearchEngineExplorerBase {
    friend struct InitializeBase;
    friend struct StepBase;

private:
    std::unique_ptr<SPACE_EXPLORER::SearchSpace> searchSpace;
    bool computeGoalPaths;

    [[nodiscard]] SearchStatus initialize(StateID_type initial_id) override;
    SearchStatus step() override;
    SearchStatus finalize() override;

public:
    explicit SpaceExplorer(const PLAJA::Configuration& config);
    ~SpaceExplorer() override;
    DELETE_CONSTRUCTOR(SpaceExplorer)

    /* Override stats. */
    void print_statistics() const override;

};

#endif //PLAJA_SPACE_EXPLORER_H
