//
// This file is part of the PlaJA code base (2019 - 2021).
//

#ifndef PLAJA_SEARCH_PA_MACROS_H
#define PLAJA_SEARCH_PA_MACROS_H

#include "../predicate_abstraction.h"
#include "../search_pa_path.h"
#include "../heuristic/pa_heuristic.h"

namespace PA_COMPUTATION_AUX {

    template<typename SearchPA_t>
    constexpr bool is_path_search() { return std::is_same_v<SearchPA_t, SearchPAPath>; }
    template<typename SearchPA_t>
    constexpr bool is_pa() { return std::is_same_v<SearchPA_t, PredicateAbstraction>; }
    template<typename SearchPA_t>
    constexpr bool is_pa_heuristic() { return std::is_same_v<SearchPA_t, PAHeuristic>; }

#if 0
    template<typename SearchNodeInfo_t>
    inline SearchNodeInfo_t* cast_node(SEARCH_SPACE_PA::SearchNodeInfo* node) { DYNAMIC_TYPE_IS(node, SearchNodeInfo_t) return static_cast<SearchNodeInfo_t*>(node); }
    template<typename SearchNodeInfo_t>
    inline const SearchNodeInfo_t* cast_node(const SEARCH_SPACE_PA::SearchNodeInfo* node) { DYNAMIC_TYPE_IS(node, SearchNodeInfo_t) return static_cast<const SearchNodeInfo_t*>(node); }
#endif

#if 0
    template<typename SearchSpace_t>
    inline SearchSpace_t* cast_search_space(SearchSpacePABase* node) { DYNAMIC_TYPE_IS(node, SearchSpace_t) return static_cast<SearchSpace_t*>(node); }
    template<typename SearchSpace_t>
    inline const SearchSpace_t* cast_search_space(const SearchSpacePABase* node) { DYNAMIC_TYPE_IS(node, SearchSpace_t) return static_cast<const SearchSpace_t*>(node); }
#endif

};

/**********************************************************************************************************************/

#endif //PLAJA_SEARCH_PA_MACROS_H
