//
// This file is part of the PlaJA code base (2019 - 2023).
//

#include "pred_entailment_cache_interface.h"
#include "../search_space/search_space_pa_base.h"

PredEntailmentCacheInterface::PredEntailmentCacheInterface(SearchSpacePABase* search_space, const PATransitionStructure* transition_, const class PredicateRelations* predicate_relations):
    searchSpace(search_space)
    , transition(transition_)
    , predicateRelations(predicate_relations)
    , numPredsChecked(0) {}

void PredEntailmentCacheInterface::load_entailment(PredicateState& target) const {
    PLAJA_ASSERT(static_cast<bool>(searchSpace) == static_cast<bool>(transition))
    if (searchSpace) { searchSpace->load_entailments(target, *transition, predicateRelations); }
}

void PredEntailmentCacheInterface::store_entailment(const std::unordered_map<PredicateIndex_type, bool>& entailments) const {
    PLAJA_ASSERT(static_cast<bool>(searchSpace) == static_cast<bool>(transition))
    if (searchSpace) { searchSpace->store_entailments(*transition, entailments); }
}
