//
// This file is part of the PlaJA code base (2019 - 2021).
//

#ifndef PLAJA_SEARCH_PA_PATH_H
#define PLAJA_SEARCH_PA_PATH_H

#include "base/search_pa_base.h"

class SearchPAPath: public SearchPABase {
    friend struct InitializePABase;
    friend class ExpansionPABase;

private:
    SearchStatus initialize() override;
    SearchStatus step() override;

public:
    explicit SearchPAPath(const SearchEngineConfigPA& config);
    ~SearchPAPath() override;

    HeuristicValue_type search_path(StateID_type src_id);
    HeuristicValue_type get_goal_distance(const AbstractState &pa_state) override;

};

#endif //PLAJA_SEARCH_PA_PATH_H
