//
// This file is part of the Marabou extension for PlaJA (2019 - 2024).
//

#ifndef PLAJA_SMT_CONSTRAINT_H
#define PLAJA_SMT_CONSTRAINT_H

#include "../../../utils/default_constructors.h"
#include "forward_smt.h"

namespace PLAJA {

    class SmtConstraint {
    protected:
        SmtConstraint();
        DEFAULT_CONSTRUCTOR_ONLY(SmtConstraint)
    public:
        virtual ~SmtConstraint() = 0;
        DELETE_ASSIGNMENT(SmtConstraint)

        virtual void add_to_solver(PLAJA::SmtSolver& solver) const = 0;
        virtual void add_negation_to_solver(PLAJA::SmtSolver& solver) const = 0;

    };

}

#endif //PLAJA_SMT_CONSTRAINT_H
