//
// This file is part of the Marabou extension for PlaJA (2019 - 2023).
//

#include "smt_solver.h"
#include "smt_constraint.h"

PLAJA::SmtSolver::SmtSolver(PLAJA::StatsBase* stats):
    unknownHandling(UnknownHandling::Error)
    , unknownRlt(false)
    , sharedStatistics(stats) {
}

PLAJA::SmtSolver::~SmtSolver() = default;

/* */

void PLAJA::SmtSolver::add_smt_constraint(const PLAJA::SmtConstraint& constraint) { constraint.add_to_solver(*this); }

void PLAJA::SmtSolver::pop_repeated(unsigned int n) {
    while (n > 0) {
        pop();
        --n;
    }
}

/* */

std::unique_ptr<bool> PLAJA::SmtSolver::pre_check() { return nullptr; }
