//
// This file is part of the PlaJA code base (2019 - 2023).
//

#ifndef PLAJA_OUTPUT_CONSTRAINTS_IN_Z3_H
#define PLAJA_OUTPUT_CONSTRAINTS_IN_Z3_H

#include <memory>
#include <vector>
#include "../../../utils/default_constructors.h"
#include "../../../assertions.h"
#include "../../information/jani2nnet/using_jani2nnet.h"
#include "../utils/forward_z3.h"
#include "../using_smt.h"

class NNInZ3;


namespace Z3_IN_PLAJA {

class OutputConstraints final {

private:
    std::vector<std::unique_ptr<z3::expr>> argmaxConstraints;

public:
    explicit OutputConstraints(const NNInZ3& nn_in_z3);
    ~OutputConstraints();
    DELETE_CONSTRUCTOR(OutputConstraints)

    [[nodiscard]] inline const z3::expr& get(OutputIndex_type output) const { PLAJA_ASSERT(output < argmaxConstraints.size()) return *argmaxConstraints[output]; }
    void add(Z3_IN_PLAJA::SMTSolver& solver, OutputIndex_type output) const;

};

}

#endif //PLAJA_OUTPUT_CONSTRAINTS_IN_Z3_H
