//
// This file is part of the PlaJA code base (2019 - 2022).
//

#ifndef PLAJA_SOLUTION_ENUMERATOR_NAIVE_H
#define PLAJA_SOLUTION_ENUMERATOR_NAIVE_H

#include <list>
#include "../../../parser/using_parser.h"
#include "../../../utils/default_constructors.h"

// forward declaration:
class Expression;
class ModelInformation;
class StateValues;

class SolutionEnumeratorNaive {
private:
    const ModelInformation& modelInformation;
    const Expression& stateCondition;
    std::list<StateValues> solutions;

    void compute_solutions_rec(VariableIndex_type state_index, StateValues& state_values);

    SolutionEnumeratorNaive(const ModelInformation& model_info, const Expression& state_condition);
public:
    ~SolutionEnumeratorNaive();
    DELETE_CONSTRUCTOR(SolutionEnumeratorNaive)

    static std::list<StateValues> compute_solutions(const Expression& state_condition, const ModelInformation& model_info);
};


#endif //PLAJA_SOLUTION_ENUMERATOR_NAIVE_H
