//
// This file is part of the Marabou extension for PlaJA (2019 - 2023).
//

#ifndef PLAJA_STRING_UTILS_H
#define PLAJA_STRING_UTILS_H

#include <unordered_set>
#include "utils.h"

namespace PLAJA {

    struct StringHash {
        std::size_t operator()(const std::string* str) const {
            PLAJA_ASSERT(str)
            return PLAJA_UTILS::hashString(*str);
        }
    };

    struct StringEqual {
        bool operator()(const std::string* str1, const std::string* str2) const {
            PLAJA_ASSERT(str1)
            PLAJA_ASSERT(str2)
            return *str1 == *str2;
        }
    };

    typedef std::unordered_set<const std::string*, StringHash, StringEqual> StringSet;

}

#endif //PLAJA_STRING_UTILS_H
